/*
 * This file is generated by jOOQ.
 */
package de.ship.db.tables;


import de.ship.db.CommonDd;
import de.ship.db.tables.records.VRestSearchRecord;

import java.util.Collection;

import org.jooq.Condition;
import org.jooq.Field;
import org.jooq.JSONB;
import org.jooq.Name;
import org.jooq.PlainSQL;
import org.jooq.QueryPart;
import org.jooq.SQL;
import org.jooq.Schema;
import org.jooq.Select;
import org.jooq.Stringly;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.TableOptions;
import org.jooq.impl.DSL;
import org.jooq.impl.SQLDataType;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class VRestSearch extends TableImpl<VRestSearchRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * The reference instance of <code>common_dd.v_rest_search</code>
     */
    public static final VRestSearch V_REST_SEARCH = new VRestSearch();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<VRestSearchRecord> getRecordType() {
        return VRestSearchRecord.class;
    }

    /**
     * The column <code>common_dd.v_rest_search.unique_name</code>.
     */
    public final TableField<VRestSearchRecord, String> UNIQUE_NAME = createField(DSL.name("unique_name"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>common_dd.v_rest_search.element_path</code>.
     */
    public final TableField<VRestSearchRecord, String> ELEMENT_PATH = createField(DSL.name("element_path"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>common_dd.v_rest_search.short_name</code>.
     */
    public final TableField<VRestSearchRecord, String> SHORT_NAME = createField(DSL.name("short_name"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>common_dd.v_rest_search.translation</code>.
     */
    public final TableField<VRestSearchRecord, JSONB> TRANSLATION = createField(DSL.name("translation"), SQLDataType.JSONB, this, "");

    /**
     * The column <code>common_dd.v_rest_search.annotation</code>.
     */
    public final TableField<VRestSearchRecord, JSONB> ANNOTATION = createField(DSL.name("annotation"), SQLDataType.JSONB, this, "");

    /**
     * The column <code>common_dd.v_rest_search.notes</code>.
     */
    public final TableField<VRestSearchRecord, JSONB> NOTES = createField(DSL.name("notes"), SQLDataType.JSONB, this, "");

    private VRestSearch(Name alias, Table<VRestSearchRecord> aliased) {
        this(alias, aliased, (Field<?>[]) null, null);
    }

    private VRestSearch(Name alias, Table<VRestSearchRecord> aliased, Field<?>[] parameters, Condition where) {
        super(alias, null, aliased, parameters, DSL.comment(""), TableOptions.view("""
        create view "v_rest_search" as  WITH RECURSIVE x(unique_name, element_path, pk, fk_parent) AS (
                SELECT COALESCE(t_core_element_hierarchy.unique_name, t_core_element_hierarchy.dn) AS "coalesce",
                   COALESCE(t_core_element_hierarchy.unique_name, t_core_element_hierarchy.dn) AS "coalesce",
                   t_core_element_hierarchy.key_element,
                   t_core_element_hierarchy.key_parent_element
                  FROM common_dd.t_core_element_hierarchy
                 WHERE (t_core_element_hierarchy.key_parent_element IS NULL)
               UNION ALL
                SELECT COALESCE(h.unique_name, h.dn) AS "coalesce",
                   ((x_1.element_path || '/'::text) || COALESCE(h.unique_name, h.dn)),
                   h.key_element,
                   h.key_parent_element
                  FROM (common_dd.t_core_element_hierarchy h
                    JOIN x x_1 ON ((x_1.pk = h.key_parent_element)))
               )
        SELECT x.unique_name,
           x.element_path,
           e.short_name,
           e.translation,
           e.annotation,
           e.notes
          FROM (x
            LEFT JOIN common_dd.v_rest_element e ON ((e.unique_name = x.unique_name)));
        """), where);
    }

    /**
     * Create an aliased <code>common_dd.v_rest_search</code> table reference
     */
    public VRestSearch(String alias) {
        this(DSL.name(alias), V_REST_SEARCH);
    }

    /**
     * Create an aliased <code>common_dd.v_rest_search</code> table reference
     */
    public VRestSearch(Name alias) {
        this(alias, V_REST_SEARCH);
    }

    /**
     * Create a <code>common_dd.v_rest_search</code> table reference
     */
    public VRestSearch() {
        this(DSL.name("v_rest_search"), null);
    }

    @Override
    public Schema getSchema() {
        return aliased() ? null : CommonDd.COMMON_DD;
    }

    @Override
    public VRestSearch as(String alias) {
        return new VRestSearch(DSL.name(alias), this);
    }

    @Override
    public VRestSearch as(Name alias) {
        return new VRestSearch(alias, this);
    }

    @Override
    public VRestSearch as(Table<?> alias) {
        return new VRestSearch(alias.getQualifiedName(), this);
    }

    /**
     * Rename this table
     */
    @Override
    public VRestSearch rename(String name) {
        return new VRestSearch(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public VRestSearch rename(Name name) {
        return new VRestSearch(name, null);
    }

    /**
     * Rename this table
     */
    @Override
    public VRestSearch rename(Table<?> name) {
        return new VRestSearch(name.getQualifiedName(), null);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VRestSearch where(Condition condition) {
        return new VRestSearch(getQualifiedName(), aliased() ? this : null, null, condition);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VRestSearch where(Collection<? extends Condition> conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VRestSearch where(Condition... conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VRestSearch where(Field<Boolean> condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VRestSearch where(SQL condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VRestSearch where(@Stringly.SQL String condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VRestSearch where(@Stringly.SQL String condition, Object... binds) {
        return where(DSL.condition(condition, binds));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VRestSearch where(@Stringly.SQL String condition, QueryPart... parts) {
        return where(DSL.condition(condition, parts));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VRestSearch whereExists(Select<?> select) {
        return where(DSL.exists(select));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VRestSearch whereNotExists(Select<?> select) {
        return where(DSL.notExists(select));
    }
}
